-------------------------------------
-- ,    
-- 
-------------------------------------

-------------------------------------
--     
-------------------------------------
DROP DATABASE HomeBuh
GO
CREATE DATABASE HomeBuh
GO

USE HomeBuh

--   
CREATE TABLE HomeBuh.dbo.tFamily
(
 idFamily int IDENTITY(1,1), 
 vcFamilyName varchar(50),

 CONSTRAINT PK_idFamily PRIMARY KEY (idFamily)
)

--  
CREATE TABLE HomeBuh.dbo.tPeriod
(
 idPeriod int IDENTITY(1,1), 
 vcPeriodName varchar(50),

 CONSTRAINT PK_idPeriod PRIMARY KEY (idPeriod)
)

--   
CREATE TABLE HomeBuh.dbo.tOutlayType
(
 idOutlayType int IDENTITY(1,1), 
 vcOutlayTypeName varchar(50),

 CONSTRAINT PK_idOutlayType PRIMARY KEY (idOutlayType)
)

--  outlay
CREATE TABLE HomeBuh.dbo.tOutlay
(
 idOutlay int IDENTITY(1,1), 
 idOutlayType int, 
 vcOutlayName varchar(50),
 idPeriod int, 

 CONSTRAINT PK_idOutlay PRIMARY KEY (idOutlay),
 CONSTRAINT FK_idOutlayType FOREIGN KEY (idOutlayType)
   REFERENCES tOutlayType (idOutlayType),
 CONSTRAINT FK_idPeriod FOREIGN KEY (idPeriod)
   REFERENCES tPeriod (idPeriod)
)

--  
CREATE TABLE HomeBuh.dbo.tPayments
(
 idPayments int IDENTITY(1,1), 
 dDatePayments datetime, 
 idFamily int, 
 idOutlay int, 
 iNumber int, 
 fCost float, 

 CONSTRAINT PK_idPayments PRIMARY KEY (idPayments),
 CONSTRAINT FK_idOutlay FOREIGN KEY (idOutlay)
   REFERENCES tOutlay (idOutlay),
 CONSTRAINT FK_idFamily FOREIGN KEY (idFamily)
   REFERENCES tFamily (idFamily)
)

-------------------------------------
--   
-------------------------------------

--    
INSERT INTO tFamily (vcFamilyName) 
VALUES ('')

INSERT INTO tFamily (vcFamilyName) 
VALUES ('')

INSERT INTO tFamily (vcFamilyName) 
VALUES ('')

INSERT INTO tFamily (vcFamilyName) 
VALUES ('')

--   
INSERT INTO tPeriod (vcPeriodName)
VALUES ('')

INSERT INTO tPeriod (vcPeriodName)
VALUES ('')

INSERT INTO tPeriod (vcPeriodName)
VALUES ('')

INSERT INTO tPeriod (vcPeriodName)
VALUES ('')

INSERT INTO tPeriod (vcPeriodName)
VALUES ('')

INSERT INTO tPeriod (vcPeriodName)
VALUES ('')

--    
INSERT INTO tOutlayType (vcOutlayTypeName)
VALUES ('')

INSERT INTO tOutlayType (vcOutlayTypeName)
VALUES ('')

INSERT INTO tOutlayType (vcOutlayTypeName)
VALUES (' ')

INSERT INTO tOutlayType (vcOutlayTypeName)
VALUES (' ')

--   
INSERT INTO tOutlay (idOutlayType, vcOutlayName, idPeriod)
VALUES (4, '  ', 2)

INSERT INTO tOutlay (idOutlayType, vcOutlayName, idPeriod)
VALUES (1, '  ', 1)

INSERT INTO tOutlay (idOutlayType, vcOutlayName, idPeriod)
VALUES (1, ' ', 3)

INSERT INTO tOutlay (idOutlayType, vcOutlayName, idPeriod)
VALUES (2, '', 2)

INSERT INTO tOutlay (idOutlayType, vcOutlayName, idPeriod)
VALUES (2, '', 3)

INSERT INTO tOutlay (idOutlayType, vcOutlayName, idPeriod)
VALUES (3, ' ', 3)

INSERT INTO tOutlay (idOutlayType, vcOutlayName, idPeriod)
VALUES (3, '', 3)

INSERT INTO tOutlay (idOutlayType, vcOutlayName, idPeriod)
VALUES (3, '', 2)

INSERT INTO tOutlay (idOutlayType, vcOutlayName, idPeriod)
VALUES (3, '', 4)

INSERT INTO tOutlay (idOutlayType, vcOutlayName, idPeriod)
VALUES (1, '', 3)

--     
INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.01.2005', 1, 1, 10, '5.00')

INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.02.2005', 2, 1, 30, '5.00')

INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.03.2005', 3, 1, 30, '5.00')

INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.03.2005', 2, 2, 1, '100.00')

INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.04.2005', 2, 3, 1, '150.00')

INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.05.2005', 3, 3, 2, '150.00')

INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.06.2005', 2, 4, 30, '7.50')

INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.07.2005', 1, 5, 10, '17.50')

INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.07.2005', 3, 6, 1, '170.00')

INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.08.2005', 4, 7, 10, '12.50')

INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.09.2005', 3, 8, 100, '14.00')

INSERT INTO tPayments (dDatePayments, idFamily, 
   idOutlay, iNumber, fCost)
VALUES ('01.11.2005', 3, 8, 100, '14.00')

-------------------------------------
--    
-------------------------------------

--   
SELECT vcFamilyName, dDatePayments, vcOutlayName, vcOutlayTypeName, 
    iNumber, fCost, iNumber*fCost AS '', vcPeriodName
FROM tPayments p, tOutlayType ot, tOutlay o, tFamily f, tPeriod pr
WHERE p.idOutlay=o.idOutlay 
   AND o.idOutlayType=ot.idOutlayType
   AND p.idFamily=f.idFamily 
   AND pr.idPeriod=o.idPeriod

--   
SELECT o.vcOutlayName, fCost*iNumber AS ''
FROM tPayments p, tOutlay o
WHERE p.idOutlay=o.idOutlay 

SELECT o.vcOutlayName, SUM(fCost*iNumber) ''
FROM tPayments p, tOutlay o
WHERE p.idOutlay=o.idOutlay 
GROUP BY o.vcOutlayName

--   
SELECT ot.vcOutlayTypeName, fCost*iNumber AS ''
FROM tPayments p, tOutlayType ot, tOutlay o
WHERE p.idOutlay=o.idOutlay 
   AND o.idOutlayType=ot.idOutlayType

SELECT ot.vcOutlayTypeName, SUM(fCost*iNumber) ''
FROM tPayments p, tOutlayType ot, tOutlay o
WHERE p.idOutlay=o.idOutlay 
   AND o.idOutlayType=ot.idOutlayType
GROUP BY ot.vcOutlayTypeName
  
--    
SELECT f.vcFamilyName, SUM(fCost*iNumber) ''
FROM tPayments p, tFamily f
WHERE p.idFamily=f.idFamily
GROUP BY f.vcFamilyName

--    
SELECT f.vcFamilyName, ot.vcOutlayTypeName, o.vcOutlayName, SUM(fCost*iNumber)
FROM tPayments p, tOutlayType ot, tOutlay o, tFamily f
WHERE p.idOutlay=o.idOutlay AND ot.idOutlayType=o.idOutlayType
   AND dDatePayments>='01.01.2004' and dDatePayments<='01.01.2006'
   AND p.idFamily=f.idFamily
GROUP BY f.vcFamilyName, ot.vcOutlayTypeName, o.vcOutlayName

-------------------------------------
--  
-------------------------------------
SELECT f.vcFamilyName, ot.vcOutlayTypeName, o.vcOutlayName, SUM(fCost*iNumber)
FROM tPayments p, tOutlayType ot, tOutlay o, tFamily f
WHERE p.idOutlay=o.idOutlay AND ot.idOutlayType=o.idOutlayType
   AND dDatePayments>='01.01.2004' and dDatePayments<='01.01.2006'
   AND p.idFamily=f.idFamily
GROUP BY f.vcFamilyName, ot.vcOutlayTypeName, o.vcOutlayName
WITH CUBE

--  
SELECT f.vcFamilyName, ot.vcOutlayTypeName, o.vcOutlayName, MAX(fCost*iNumber)
FROM tPayments p, tOutlayType ot, tOutlay o, tFamily f
WHERE p.idOutlay=o.idOutlay AND ot.idOutlayType=o.idOutlayType
   AND dDatePayments>='01.01.2004' and dDatePayments<='01.01.2006'
   AND p.idFamily=f.idFamily
GROUP BY f.vcFamilyName, ot.vcOutlayTypeName, o.vcOutlayName
WITH CUBE

--   Rollup
SELECT f.vcFamilyName, ot.vcOutlayTypeName, 
       o.vcOutlayName, SUM(fCost*iNumber)
FROM tPayments p, tOutlayType ot, tOutlay o, tFamily f
WHERE p.idOutlay=o.idOutlay 
   AND ot.idOutlayType=o.idOutlayType
   AND dDatePayments>='01.01.2004' 
   AND dDatePayments<='01.01.2006'
   AND p.idFamily=f.idFamily
GROUP BY f.vcFamilyName, ot.vcOutlayTypeName, o.vcOutlayName
WITH ROLLUP
